HanMacWrdJParser Class Referencefinal

the main class to read a HanMac Word-J file More...

`#include <HanMacWrdJParser.hxx>`

Inheritance diagram for HanMacWrdJParser:

## Public Member Functions

| HanMacWrdJParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor
| ~HanMacWrdJParser () final
| destructor
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not)
void | parse (librevenge::RVNGTextInterface *documentInterface) final
| virtual function used to parse the input
Public Member Functions inherited from MWAWTextParser
| ~MWAWTextParser () override
| destructor
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor
int | version () const
| returns the works version
MWAWParserStatePtr | getParserState ()
| returns the parser state
MWAWHeader * | getHeader ()
| returns the header
MWAWInputStreamPtr & | getInput ()
| returns the actual input
MWAWListenerPtr | getMainListener ()
| returns the main listener
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension
double | getFormLength () const
| returns the form length
double | getFormWidth () const
| returns the form width
double | getPageLength () const
| returns the page length (form length without margin )
double | getPageWidth () const
| returns the page width (form width without margin )
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document

## Protected Member Functions

void | init ()
| inits all internal variables
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document
bool | createZones ()
| finds the different objects zones in a Hapanese File
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches)
void | newPage (int number)
| adds a new page
bool | sendText (long id, long cPos, MWAWListenerPtr listener=MWAWListenerPtr())
| send a text zone
bool | canSendTextAsGraphic (long id, long cPos)
| check if we can send a textzone as graphic
bool | sendZone (long zId)
| send a zone
bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern
bool | checkEntry (MWAWEntry &entry)
| look in entry.begin() to see if a entry exists at this position, if so fills entry.end(), entry.id(), ...
bool | readZonesList ()
| try to read the zones list
bool | readZone (MWAWEntry &entry)
| try to read a generic zone
bool | readClassicHeader (HanMacWrdJZoneHeader &header, long endPos=-1)
| try to read a header of classic zone
bool | decodeZone (MWAWEntry const &entry, librevenge::RVNGBinaryData &data)
| try to decode a zone
bool | readPrintInfo (MWAWEntry const &entry)
| try to read a printinfo zone
bool | readHeaderEnd ()
| try to read a unknown zone, just after the header (simillar to HanMacWrd Zoneb)
bool | readZoneA (MWAWEntry const &entry)
| try to read the zone A ( a big zone containing 5 sub zone ?
bool | readZoneB (MWAWEntry const &entry)
| try to read the zone B
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWTextParser (MWAWParserStatePtr const &state)
| constructor using a state
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected)
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state
void | setVersion (int vers)
| sets the document's version
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener
void | resetGraphicListener ()
| resets the listener
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener
void | resetPresentationListener ()
| resets the listener
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener
void | resetSpreadsheetListener ()
| resets the listener
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener
void | resetTextListener ()
| resets the listener
void | setAsciiName (char const *name)
| Debugging: change the default ascii file.
std::string const & | asciiName () const
| return the ascii file name

## Protected Attributes

std::shared_ptr< HanMacWrdJParserInternal::State > | m_state
| the state
std::shared_ptr< HanMacWrdJGraph > | m_graphParser
| the graph parser
std::shared_ptr< HanMacWrdJText > | m_textParser
| the text parser

## Friends

class | HanMacWrdJGraph
class | HanMacWrdJText
class | HanMacWrdJParserInternal::SubDocument

## Detailed Description

the main class to read a HanMac Word-J file

## Constructor & Destructor Documentation

## HanMacWrdJParser()

HanMacWrdJParser::HanMacWrdJParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header )

constructor

## ~HanMacWrdJParser()

HanMacWrdJParser::~HanMacWrdJParser | ( |  | ) |

final

destructor

## Member Function Documentation

## canSendTextAsGraphic()

bool HanMacWrdJParser::canSendTextAsGraphic | ( | long | id,
|  | long | cPos )

protected

check if we can send a textzone as graphic

Referenced by HanMacWrdJParserInternal::SubDocument.

## checkEntry()

bool HanMacWrdJParser::checkEntry | ( | MWAWEntry & | entry | ) |

protected

look in entry.begin() to see if a entry exists at this position, if so fills entry.end(), entry.id(), ...

Referenced by createZones(), HanMacWrdJParserInternal::SubDocument, and readZonesList().

## checkHeader()

bool HanMacWrdJParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = false )

final virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by HanMacWrdJParserInternal::SubDocument, and parse().

## createDocument()

void HanMacWrdJParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

protected

creates the listener which will be associated to the document

Referenced by HanMacWrdJParserInternal::SubDocument, and parse().

## createZones()

bool HanMacWrdJParser::createZones | ( |  | ) |

protected

finds the different objects zones in a Hapanese File

Referenced by HanMacWrdJParserInternal::SubDocument, and parse().

## decodeZone()

bool HanMacWrdJParser::decodeZone | ( | MWAWEntry const & | entry,
|  | librevenge::RVNGBinaryData & | data )

protected

try to decode a zone

Referenced by HanMacWrdJParserInternal::SubDocument.

## getColor()

bool HanMacWrdJParser::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color ) const

protected

returns the color associated with a pattern

Referenced by HanMacWrdJParserInternal::SubDocument.

## getPageLeftTop()

MWAWVec2f HanMacWrdJParser::getPageLeftTop | ( |  | ) | const

protected

returns the page left top point ( in inches)

Referenced by HanMacWrdJParserInternal::SubDocument.

## init()

void HanMacWrdJParser::init | ( |  | ) |

protected

inits all internal variables

Referenced by HanMacWrdJParser(), and HanMacWrdJParserInternal::SubDocument.

## newPage()

void HanMacWrdJParser::newPage | ( | int | number | ) |

protected

adds a new page

Referenced by HanMacWrdJParserInternal::SubDocument.

## parse()

void HanMacWrdJParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |

final virtual

virtual function used to parse the input

Implements MWAWTextParser.

Referenced by HanMacWrdJParserInternal::SubDocument.

## readClassicHeader()

bool HanMacWrdJParser::readClassicHeader | ( | HanMacWrdJZoneHeader & | header,
|  | long | endPos = -1 )

protected

try to read a header of classic zone

Referenced by HanMacWrdJParserInternal::SubDocument, readZoneA(), and readZoneB().

## readHeaderEnd()

bool HanMacWrdJParser::readHeaderEnd | ( |  | ) |

protected

try to read a unknown zone, just after the header (simillar to HanMacWrd Zoneb)

Referenced by createZones(), and HanMacWrdJParserInternal::SubDocument.

## readPrintInfo()

bool HanMacWrdJParser::readPrintInfo | ( | MWAWEntry const & | entry | ) |

protected

try to read a printinfo zone

Referenced by checkHeader(), and HanMacWrdJParserInternal::SubDocument.

## readZone()

bool HanMacWrdJParser::readZone | ( | MWAWEntry & | entry | ) |

protected

try to read a generic zone

Referenced by createZones(), and HanMacWrdJParserInternal::SubDocument.

## readZoneA()

bool HanMacWrdJParser::readZoneA | ( | MWAWEntry const & | entry | ) |

protected

try to read the zone A ( a big zone containing 5 sub zone ?

)

Referenced by readZone().

## readZoneB()

bool HanMacWrdJParser::readZoneB | ( | MWAWEntry const & | entry | ) |

protected

try to read the zone B

Referenced by readZone().

## readZonesList()

bool HanMacWrdJParser::readZonesList | ( |  | ) |

protected

try to read the zones list

Referenced by createZones(), and HanMacWrdJParserInternal::SubDocument.

## sendText()

bool HanMacWrdJParser::sendText | ( | long | id,
|  | long | cPos,
|  | MWAWListenerPtr | listener = MWAWListenerPtr() )

protected

send a text zone

Referenced by HanMacWrdJParserInternal::SubDocument.

## sendZone()

bool HanMacWrdJParser::sendZone | ( | long | zId | ) |

protected

send a zone

Referenced by HanMacWrdJParserInternal::SubDocument.

## Friends And Related Symbol Documentation

## HanMacWrdJGraph

friend class HanMacWrdJGraph

friend

Referenced by HanMacWrdJGraph, and init().

## HanMacWrdJParserInternal::SubDocument

friend class HanMacWrdJParserInternal::SubDocument

friend

## HanMacWrdJText

friend class HanMacWrdJText

friend

Referenced by HanMacWrdJText, and init().

## Member Data Documentation

## m_graphParser

std::shared_ptr<HanMacWrdJGraph> HanMacWrdJParser::m_graphParser

protected

the graph parser

Referenced by createDocument(), createZones(), getColor(), HanMacWrdJParser(), init(), parse(), readZone(), and sendZone().

## m_state

std::shared_ptr<HanMacWrdJParserInternal::State> HanMacWrdJParser::m_state

protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getPageLeftTop(), HanMacWrdJParser(), init(), newPage(), readZone(), and readZonesList().

## m_textParser

std::shared_ptr<HanMacWrdJText> HanMacWrdJParser::m_textParser

protected

the text parser

Referenced by canSendTextAsGraphic(), createDocument(), createZones(), HanMacWrdJParser(), init(), parse(), readZone(), and sendText().

The documentation for this class was generated from the following files:

- HanMacWrdJParser.hxx
- HanMacWrdJParser.cxx